/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package worldclient;

//Imports
import java.io.*;
import java.net.*;
import java.util.Arrays;

/**
 *
 * @author Guilherme
 */
public class WorldClient {
    private int setSpeed = 0;
    private int id = 0;
    private int angle = 0;
    private OutputStream outStream;
    private PrintStream worldElement;
    private BufferedReader in = null;
    private Socket socket;
    private boolean movingForward = false;
    private boolean movingBackward = false;
    private String responseLine;

    public WorldClient(int value) throws ClassNotFoundException 
    {
       try {
            //Create a socket
            socket = new Socket("127.0.0.1", 4011);
        
            //create stream for data transfering
            outStream = socket.getOutputStream();
            worldElement = new PrintStream(outStream);
            //waiting connect answer
            in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
            //treat return
            while (!in.ready());
            while (in.ready())
            {
                responseLine = in.readLine();
                System.out.println(responseLine);
                if (responseLine.indexOf("Welcome to the game") != -1) 
                {
                   System.out.println("Connected");
                }
            }
            //set creature id based on constructor
            setId(value);
                       
        //in case host is not found, thrown exception    
        } catch (UnknownHostException ex) {
            ex.printStackTrace();
        //in case io stream problem, thrown exception
        } catch (IOException ex) {
            ex.printStackTrace();
	}
    }
    
    public boolean isGameRunning() throws IOException
    {
        boolean ret = false;
        //getting game status
        worldElement.println("game");
        System.out.println("game");
        //treat return
        while (!in.ready());
        while (in.ready())
        {
            responseLine = in.readLine();
            System.out.println(responseLine);
            if (responseLine.indexOf("yes") != -1) 
            {
               System.out.println("Game Started");
               ret = true;
            }
            else if (responseLine.indexOf("no") != -1) 
            {
               System.out.println("Game Not Running");
               ret = false;
            }
        }
        return ret;
    }
    public void startGame() throws IOException
    {
        //getting game status
        worldElement.println("startGame");
        //treat return
        System.out.println("startGame");
        while (!in.ready());
        while (in.ready())
        {
            responseLine = in.readLine();
            System.out.println(responseLine);
        };
    }
    public void moveForward() throws IOException
    {
        movingForward = true;
        setAngleCreature();
        worldElement.println("start "+id);
        System.out.println("start "+id);
        //treat return
        while (!in.ready());
        while (in.ready())
        {
            responseLine = in.readLine();
            System.out.println(responseLine);
        }; 
    }
    public void moveBackward() throws IOException
    {
        movingBackward = true;
        setAngleCreature();
        worldElement.println("start "+id);
        System.out.println("start "+id);
        //treat response
        while (!in.ready());
        while (in.ready())
        {
            responseLine = in.readLine();
            System.out.println(responseLine);
        }
    }
    public void stop() throws IOException
    {
        worldElement.println("stop "+id);
        System.out.println("stop "+id);
        movingBackward = false;
        movingForward = false;
        //treat return
        while (!in.ready());
        while (in.ready())
        {
            responseLine = in.readLine();
            System.out.println(responseLine);
        };
    }
    public void turnRight(int value) throws IOException
    {
        angle = angle+value;
        angle = angle%360;
        setAngleCreature();
    }
    public void turnLeft(int value) throws IOException
    {
        angle = angle-value;
        angle = angle%360;
        setAngleCreature();
    }
    public void setAngle(int value) throws IOException
    {
        angle = value%360;
        setAngleCreature();
    }
    public void setId(int value)
    {
        id = value;
    }
    public void refuel() throws IOException
    {
        worldElement.println("refuel "+id);
        System.out.println("refuel "+id);
        //treat return
        while (!in.ready());
        while (in.ready())
        {
            responseLine = in.readLine();
            System.out.println(responseLine);
        };
    }
    public void increaseSpeed() throws IOException
    {
        setSpeed = setSpeed + 1;
        setAngleCreature();
    }
    public void decreaseSpeed() throws IOException
    {
        if (setSpeed > 0)
        {
          setSpeed = setSpeed - 1;
          setAngleCreature();
        }
    }
    public void setSpeed(int value) throws IOException
    {
        if (value > 0)
        {
          setSpeed = value;
          setAngleCreature();
        }
    }
    private void setAngleCreature() throws IOException
    {
        if (movingForward)
        {
            worldElement.println("setAngle "+id+" "+setSpeed+" "+setSpeed+" "+Math.toRadians(angle));
            System.out.println("setAngle "+id+" "+setSpeed+" "+setSpeed+" "+Math.toRadians(angle));
        }
        else
        {
            worldElement.println("setAngle "+id+" -"+setSpeed+" -"+setSpeed+" "+Math.toRadians(angle));
            System.out.println("setAngle "+id+" -"+setSpeed+" -"+setSpeed+" "+Math.toRadians(angle));
        }
        //treat return
        while (!in.ready());
        while (in.ready())
        {
            responseLine = in.readLine();
            System.out.println(responseLine);
        };
    }
}

